local RockSaltMine = ...

RockSaltMine:register({
    DataType = "BUILDING",
    Id = RockSaltMinePrefix,
    Name = RockSaltMinePrefix .. "_NAME",
    Description = RockSaltMinePrefix .. "_DESC",
    BuildingType = "GENERAL",
    AssetCoreBuildingPart = RockSaltMinePrefix .. "_PART"
})

-- Register common prefab nodes
RockSaltMine:registerAssetId("models/rocksaltmine.fbx/Prefab/rocksaltminePart", RockSaltMinePrefix .. "_PREFAB")

-- Register the rock salt mine part
RockSaltMine:register({
	DataType = "BUILDING_PART",
	Id = RockSaltMinePrefix .. "_PART",
        BuildingZone = { ZoneEntryList = {
            { Polygon = polygon.createRectangle( {6, 4} ),
              Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } }
        }},
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = RockSaltMinePrefix .. "_PREFAB"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "WOOD", Quantity = 5 },
			{ Resource = "TOOL", Quantity = 2 }
		}
	},
	AssetBuildingFunction = RockSaltMinePrefix .. "_FUNCTION"
})

RockSaltMine:register({
		DataType = "BUILDING_FUNCTION_WORKPLACE",
                Id = RockSaltMinePrefix .. "_FUNCTION",
		WorkerCapacity = 3,
                RelatedJob = { Job = "MINER", Behavior = "BEHAVIOR_WORK" },
                InputInventoryCapacity = {
			{ Resource = "WATER", Quantity = 50 }
                },
                ResourceListNeeded = {
                	{ Resource = "WATER", Quantity = 2 }
                },
                ResourceProduced = {
			{ Resource = SaltPrefix .. "_BRINE", Quantity = 1 }
                }
})

RockSaltMine:registerPrefabComponent("models/rocksaltmine.fbx/Prefab/rocksaltminePart", {
	DataType = "COMP_DIRT_RECTANGLE",
	Size = {6, 4}
})

-- Override building part components properties (generated by the building asset processor) to add building zones

RockSaltMine:registerPrefabComponent("models/rocksaltmine.fbx/Prefab/rocksaltminePart", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = { 6, 4 }
})
